

#the ip to add for the bans (obv. cant be real)
fake_ip = '0.0.0.0'

#the gamename to use (too difficult to parse)
gamename = ' '

#mysql database information
db_host = 'localhost'
db_user = 'root'
db_pw = 'CD1QhmIRO3kFGihCjvs0pJxl2'
db_database = 'ghostdb'
bot_id = 1

#vip-rank regex (for searching)
rank_match = r'(Approved Host|XML Contributor)'


########################################################################
#########################do work!#######################################
########################################################################
from datetime import datetime
import re
try:
	import PyBlnl2
	import MySQLdb
except ImportError:
	print('Will not work without PyBlnl and MySQLdb...')
	raise

def create_mysql_insert_bans( mysql_conn, banlists):
	'''Constructs a mysql_insert string from a list of banlist objects
		(inserting all at the same time is much faster, at the cost of 
		memory required to save the string)
		
		Keyword Arguments:
		mysql_conn --a mysql connection (necessary to escape strings)
		banlists --a list of banlists to convert into a ghost++ sql statement
		
		returns --an SQL statement to insert bans into your bans table
	'''
	mysql_insert_half = """INSERT INTO bans 
		(botid, server, ip, date, gamename, admin, name, reason)
		VALUES\n"""
		
	mysql_update_half ="""\nON DUPLICATE KEY UPDATE
							admin = VALUES(admin),
							date = VALUES(date), 
							reason = VALUES(reason); """
	mysql_banstring = "( {botid}, '{server}', '{ip}', '{date}', '{gn}', '{admin}', '{name}', '{reason}' )"
	
	
	value_list = list()
	
	for banlist in banlists:
		for ban in banlist:
			if banlist.has_dates:
				date_banned = datetime.strftime(ban[2], '%Y-%m-%d 00:00:00')
			else:
				date_banned = datetime.today().strftime('%Y-%m-%d 00:00:00')
			#escape!!!!!!!!!!!!!!!!!!!!!!!!!!!111
			values = mysql_banstring.format(
				botid=bot_id, 
				server=PyBlnl2.lookup_realm(banlist.realm),
				ip=fake_ip,
				date=mysql_conn.escape_string(date_banned),
				gn=mysql_conn.escape_string(gamename),
				admin=mysql_conn.escape_string(banlist.banner),
				name=mysql_conn.escape_string(ban[0]),
				reason=mysql_conn.escape_string(ban[1])
			)
			value_list.append(values)
			
	#seems strange, but this is actually a very efficient way to concat strings
	built_string = ',\n'.join(value_list)
	
	return mysql_insert_half + built_string + mysql_update_half

if __name__=='__main__':
	try:
		ghost_conn = MySQLdb.connect (host = db_host, user = db_user, passwd = db_pw, db = db_database)
	except MySQLdb.Error:
		print('Could not connect to your Mysqldb properly, are you sure its configured properly?')
		raise
	curs = ghost_conn.cursor()
	
	##download xml banlists
	#xmls = (PyBlnl2.NORTHREND_XML_LIST, PyBlnl2.NORTHREND_AH_LIST)
	#for xml in xmls:
		#dled_banlists = PyBlnl2.download_bans_xml(xml)
		#insert_bans = create_mysql_insert_bans(ghost_conn, dled_banlists)
		#curs.execute("""LOCK TABLES `bans` WRITE""")
		#curs.execute(insert_bans)
		#curs.execute("""UNLOCK TABLES""")
	
	#download vip-list
	metadata = PyBlnl2.parse_online_xml(PyBlnl2.NORTHREND_VIP_LIST)
	viplist = PyBlnl2.download_viplist(PyBlnl2.NORTHREND_VIP_LIST)
	
	for vip, rank, banlist_acc in viplist:
		if re.search(rank_match, rank):
			curs.execute("""INSERT IGNORE INTO admins ( botid, server, name )
						 VALUES ( %s, %s, %s) """, (bot_id, 
						 PyBlnl2.lookup_realm(metadata['realm']),vip))
	curs.close()
	ghost_conn.commit()
	ghost_conn.close()
